unit Main;

{
-- Running Chronometer library --
   Main unit
   Copyright Pierre DELORE
   Version 1.0 - 23/05/2004

Feel free to use or modify this file
For any question, improvement...
send me an email at dpliste@free.fr
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls, DateUtils, Tools, Database;

Type

  TFrmMain = class(TForm)
    SGChrono: TStringGrid;
    LEDateTime: TLabeledEdit;
    LETarget: TLabeledEdit;
    LEAverage: TLabeledEdit;
    BPCreateDB: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BPCreateDBClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declaration }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}


procedure TFrmMain.FormCreate(Sender: TObject);
Var
  sRet:String;
  i:Integer;
  dt:TDateTime;
  h,m,s,d:Byte;
begin
  {- Set the grid -}
  SGChrono.Cells[0,0]:='N';
  SGChrono.ColWidths[0]:=20;
  For i:=1 to 99 do
    SGChrono.Cells[0,i]:=IntToStr(i);

  SGChrono.Cells[1,0]:='Split Time';
  SGChrono.ColWidths[1]:=100;

  SGChrono.Cells[2,0]:='Distance';
  SGChrono.ColWidths[2]:=100;

  SGChrono.Cells[3,0]:='Lap Time';
  SGChrono.ColWidths[3]:=100;

  SGChrono.Cells[4,0]:='Target Time';
  SGChrono.ColWidths[4]:=100;

  SGChrono.Cells[5,0]:='Average speed';
  SGChrono.ColWidths[5]:=100;

  {- Search, Read and display the database -}
  sRet:=SearchDB(BaseDir,'RCH',18);
  If sRet<>'' then
    Begin
      If ReadDB(sRet) then
        Begin
          dt:=EncodeDateTime(
            Bcd2Word(Buffer.StartDateYearHi,Buffer.StartDateYearLo),
            Bcd2Byte(Buffer.StartDateMonth),
            Bcd2Byte(Buffer.StartDateDay),
            Bcd2Byte(Buffer.StartTimeHour),
            Bcd2Byte(Buffer.StartTimeMin),
            Bcd2Byte(Buffer.StartTimeSec),
            0);
          LEDateTime.Text:=DateTimeToStr(dt);
          LETarget.Text:=intToStr(Buffer.TargetDist)+'.'+intToStr(Buffer.TargetDist10);

          h:=0;
          m:=0;
          s:=0;
          d:=0;
          for i:=1 to Buffer.NumRecUsed do
          Begin
            With Buffer.DistRec[i]do
            Begin
              SGChrono.Cells[1,i]:=FormatTime(Hour,Min,Sec);
              SGChrono.Cells[2,i]:=intToStr(Distance);
              SGChrono.Cells[3,i]:=LapTime(h,m,s,Hour,Min,Sec);
              SGChrono.Cells[4,i]:=TargetTime(Hour,Min,Sec,Distance,Buffer.TargetDist);
              SGChrono.Cells[5,i]:=AverageSpeed(h,m,s,Hour,Min,Sec,Distance-d);
              h:=Hour;
              m:=Min;
              s:=Sec;
              d:=Distance;
            End;
          End;
          LEAverage.Text:=AverageSpeed(0,0,0,h,m,s,d);
        End;
    end
  else
    Begin
      ShowMessage('TFrmMain.FormCreate : Database not found');
      WriteDB(BaseDir);
    End;
end;

procedure TFrmMain.BPCreateDBClick(Sender: TObject);
begin
  WriteDB(BaseDir);
end;

end.
