unit Tools;

{
-- Running Chronometer library --
   Tools unit
   Copyright Pierre DELORE
   Version 1.0 - 23/05/2004

Feel free to use or modify this file
For any question, improvement...
send me an email at dpliste@free.fr
}

interface
uses
  SysUtils;

  function Bcd2Byte(bcd:Byte):Byte;
  function Bcd2Word(bcdh,Bcdl:Byte):word;
  function FormatByte(B:Byte):String;
  function FormatTime(h,m,s:Byte):String;
  function LapTime(h1,m1,s1,h2,m2,s2:Byte):String;
  procedure Sec2Time(ls:Longint;Var h,m,s:byte);
  function TargetTime(hour,min,sec,dist,Target:Byte):String;
  function AverageSpeed(h1,m1,s1,h2,m2,s2,dist:Byte):String;

implementation

{-- Convert second to HMS --}
Procedure Sec2Time(ls:Longint;Var h,m,s:byte);
Begin
  h:=ls div 3600;
  ls:=ls-h*3600;
  m:=ls div 60;
  ls:=ls-m*60;
  s:=ls;
End;


{-- Calculate the lap time --}
Function LapTime(h1,m1,s1,h2,m2,s2:Byte):String;
Var ls1,ls2,ls:Longint;
    h,m,s:Byte;
Begin
  ls1:=h1*3600+m1*60+s1;
  ls2:=h2*3600+m2*60+s2;
  ls:=ls2-ls1;
  Sec2Time(ls,h,m,s);
  LapTime:=FormatTime(h,m,s);
End;


{-- Calculate the target time --}
Function TargetTime(hour,min,sec,dist,Target:Byte):String;
Var ls:Longint;
    h,m,s:Byte;
Begin
  ls:=((hour*3600+min*60+sec)*Target) div Dist;
  Sec2Time(ls,h,m,s);
  TargetTime:=FormatTime(h,m,s);
End;


{-- Calculate the average speed --}
Function AverageSpeed(h1,m1,s1,h2,m2,s2,dist:Byte):String;
Var ls1,ls2,ls:Longint;
    r:Double;
Begin
  ls1:=h1*3600+m1*60+s1;
  ls2:=h2*3600+m2*60+s2;
  ls:=ls2-ls1;
  if ls=0 then AverageSpeed:='';
  r:=(dist*3600)/ls;
  AverageSpeed:=Format('%-9.2f',[r]);
End;



{-- Convert Byte to String and add '0' if necessary --}
function FormatByte(B:Byte):String;
Var s:String;
Begin
  s:=intToStr(b);
  if length(s)=1 then s:='0'+s;
  FormatByte:=s;
End;


{-- Format Time hh:mm.ss --}
function FormatTime(h,m,s:Byte):String;
Begin
  FormatTime:=FormatByte(h)+ ':' +
              FormatByte(m)+ ':' +
              FormatByte(s);
End;


{-- Convert Bcd to byte --}
function Bcd2Byte(bcd:Byte):Byte;
Begin
  Bcd2Byte:=(bcd shr 4)*10 + (Bcd and $0F);
End;


{-- Convert Bcd to word --}
function Bcd2Word(bcdh,Bcdl:Byte):word;
Begin
  Bcd2Word:=(bcdh shr 4)*1000 + (Bcdh and $0F)*100 + (bcdl shr 4)*10 + (Bcdl and $0F);
End;

end.
